/* vi: set sw=4 ts=4: */
/*
 * FCALLBOX remoteDisplayTESTLinux
 *
 * Copyright (c) 2013
 *	
 * Update : 
 */
     
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>  /* ioctl */
#include <sys/poll.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/un.h>
#include <getopt.h>
#include <errno.h>
#include <termios.h>
#include <sys/socket.h>
#include <netdb.h>
#include <time.h>

// DISPLAY GRAPHICS Defines
#define SIZE_DISPLAY_GRAPHICS 8
#define GRAPHICS_MODE 	2
#define TEXT_MODE 	0


// DISPLAY COMMANDS DEFINES
#define SET_CHAR_0		0x01
#define SET_CHAR_1		0x02
#define SET_CHAR_2		0x03
#define SET_CHAR_3		0x04
#define SET_CHAR_4		0x05
#define SET_CHAR_5		0x06
#define SET_CHAR_6		0x07
#define SET_CHAR_7		0x08
#define SET_HEURE_DIZAINE	0x09
#define SET_HEURE_UNIT		0x0A
#define SET_MINUTE_DIZAINE	0x0B
#define SET_MINUTE_UNIT		0x0C
#define SET_SECONDE_DIZAINE	0x0D
#define SET_SECONDE_UNIT	0x0E
#define START_STOP_TIME_COMPUTE	0x0F
#define START_STOP_GRAPHICS	0x10
#define START_WRITE_GRAPHICS	0x11
#define DATA_WRITE_GRAPHICS	0x12
#define DISPLAY_ON_OFF		0x13
#define CHECK_SYNC		0x14


/**************/
/*  variables */ 
/**************/
struct tm *current_time;
time_t current_secs;
int fd_serial;
struct termios newtio;
char Heure   [3];
char Minute  [3];
char Seconde [3];
char Graphics [40];
	
char Digit_graphic[] = {  0x7C,0x44,0x7C,	// 0 
			  0x00,0x00,0x7C,	// 1 
			  0x5C,0x54,0x74,	// 2
			  0x44,0x54,0x7C,	// 3
			  0x70,0x10,0x7C,	// 4
			  0x74,0x54,0x5C,	// 5
			  0x7C,0x54,0x5C,	// 6
			  0x60,0x40,0x7C,	// 7 
			  0x7C,0x54,0x7C,	// 8
			  0x74,0x54,0x7C	// 9
				};
	
char Letter_graphic[] = { 0x7C,0x50,0x7C,	// A
			  0x7C,0x54,0x28,	// B 
			  0x7C,0x44,0x44,	// C
			  0x7C,0x44,0x38,	// D
			  0x7C,0x54,0x54,	// E
			  0x7C,0x50,0x50,	// F
			  0x7C,0x44,0x5C,	// G
			  0x7C,0x10,0x7C,	// H 
			  0x44,0x7C,0x44,	// I
			  0x04,0x04,0x7C,	// J
			  0x7C,0x10,0x6C,	// K
			  0x7C,0x04,0x04,	// L
			  0x7C,0x20,0x7C,	// M
			  0x7C,0x18,0x7C,	// N
			  0x7C,0x44,0x7C,	// O
			  0x7C,0x50,0x70,	// P
			  0x78,0x48,0x74,	// Q
			  0x7C,0x58,0x74,	// R
			  0x74,0x54,0x5C,	// S
			  0x40,0x7C,0x40,	// T
			  0x7C,0x04,0x7C,   	// U
			  0x78,0x04,0x78,	// V
			  0x7C,0x08,0x7C,	// W
			  0x6C,0x10,0x6C,	// X
			  0x60,0x1C,0x60,	// Y
			  0x4C,0x54,0x64	// Z
			  
			};			
				
char MESSAGE_ICON  	[] = {0xFE,0xC2,0xA2,0x92,0x8A,0x92,0xA2,0xC2,0xFE,0 };
char F_ICON  		[] = {0xFE,0x90,0x90,0};
char T_ICON  		[] = {0x80,0xFE,0x80,0 };
char b_ICON		[] = {0xFE,0x12,0x0C,0 };
char LIVING_ICON   	[] = {0x20,0x7E,0xA0,0xB8,0xA0,0xBE,0xA0,0xF8,0x80,0x01,0x74,0x54,0x5C,0x01,0x7C,0x20,0x7C,0};
char BATHROOM_ICON 	[] = {0x20,0x7E,0xBC,0xBC,0xBC,0xBE,0xB8,0xFC,0x80,0x01,0x74,0x54,0x5C,0x01,0x7C,0x54,0x28,0};
char PHONE_ICON    	[] = {0x66,0xEA,0xD2,0xD2,0xD2,0xEA,0x66,0};
char CYRILLE_ICON  	[] = {0x80,0x20,0x01,0x10,0x02,0x64,0x18,0x1C,0x1A,0x18,0x1C,0x1a,0xF8,0x64,0x62,0x40,0x01,0};
char PARENT_ICON   	[] = {0x60,0x90,0x88,0x44,0x22,0x44,0x88,0x90,0x60,0x01,0x7C,0x50,0x20,0x01,0x3C,0x50,0x3C,0};
char EXTERNAL_ICON 	[] = {0x20,0x7E,0xE2,0xEE,0xE2,0xEA,0xE2,0x7E,0x20,0x01,0x7C,0x54,0x54,0x01,0x6C,0x10,0x6C,0};
char POSITIVE_SIGN_ICON [] = {0x10,0x38,0x10,0};
char NEGATIVE_SIGN_ICON [] = {0x10,0x10,0x10,0};
char DECIMAL_POINT_ICON [] = {0x04,0};
char DEGRE_C_ICON	[] = {0x7C,0x44,0x44,0};
int i,j, indx,x;

#define BAUDRATE B115200

/**************/
/*  functions */ 
/**************/
void OpenPort (char * device);
void SendTextDisplayMatrix(char * sText);
void Set_Display_TEXT_MODE_and_STOP_TIME(void);
void Set_Display_TEXT_MODE(void);
void Set_Display_GRAPHICS_MODE(void);
void Display_RESET_GRAPHICS_INDEX(void);
void Display_WRITE_GRAPHICS(int data);
void Display_CLEAR(void);
void Display_STOP_TIME(void);
void Display_START_TIME(void);
int DisplaySendCommandData (int Cmd,int data);
void RS232_delay_bit (void);


	
void main(int argc, char** argv)	
{

	printf ("FCALLBOX3 remoteDisplayTESTLinux Version 1.00\n");

	if (argc !=3)
	{
		printf ("ERROR, need 2 arguments :\n");
		printf ("arg 1 = port device, eg : /dev/ttyUSB0 \n");
		printf ("arg 2 = action : 1 to display hour, 2 for text, 3 for graphics and 4 to light on all leds\n");
		return ;
	}
	
	OpenPort (argv[1]);	// open serial port

	if ((strcmp(argv[2],"1")==0))
	{
		printf ("display hour\n");
		Display_STOP_TIME();

		time(&current_secs);
		current_time = localtime(&current_secs);
		sprintf (Heure,"%02d",current_time->tm_hour);
		sprintf (Minute,"%02d",current_time->tm_min);
		sprintf (Seconde,"%02d",current_time->tm_sec);
	
		DisplaySendCommandData(SET_HEURE_DIZAINE,Heure[0]);
		DisplaySendCommandData(SET_CHAR_0,Heure[0]);
		DisplaySendCommandData(SET_HEURE_UNIT,Heure[1]);
		DisplaySendCommandData(SET_CHAR_1,Heure[1]);
		DisplaySendCommandData(SET_CHAR_2,':');
		DisplaySendCommandData(SET_MINUTE_DIZAINE,Minute[0]);
		DisplaySendCommandData(SET_CHAR_3,Minute[0]);
		DisplaySendCommandData(SET_MINUTE_UNIT,Minute[1]);
		DisplaySendCommandData(SET_CHAR_4,Minute[1]);
		DisplaySendCommandData(SET_CHAR_5,':');
		DisplaySendCommandData(SET_SECONDE_DIZAINE,Seconde[0]);
		DisplaySendCommandData(SET_CHAR_6,Seconde[0]);
		DisplaySendCommandData(SET_SECONDE_UNIT,Seconde[1]);
		DisplaySendCommandData(SET_CHAR_7,Seconde[1]);
		
		// start time
		Display_START_TIME();
		
		// display TEXT mode
		Set_Display_TEXT_MODE();
			
	}
		
	if ((strcmp(argv[2],"2")==0))
	{
		printf ("display text\n");
		Set_Display_TEXT_MODE_and_STOP_TIME();
		SendTextDisplayMatrix("FCALLBOX");
	}

	if ((strcmp(argv[2],"3")==0))
	{
		printf ("display graphics\n");
	
		// clear Display buffer 
		for (i=0;i<40;i++)
			Graphics[i] = 0;

		// Display graphics counter 
		indx=1;
	
		// PARENT ICON
		for (i=0;i<strlen(PARENT_ICON);i++)
			Graphics[indx++]=PARENT_ICON[i];

		Graphics[indx++]=0;

		// SIGN
		for (i=0;i<strlen(POSITIVE_SIGN_ICON);i++)
			Graphics[indx++]=POSITIVE_SIGN_ICON[i];

		Graphics[indx++]=0;

		// DIGITS
		for (x=0; x<3;x++)
			Graphics[indx++] =Digit_graphic[x+('2'-0x30)*3];
		Graphics[indx++]=0;
		
		for (x=0; x<3;x++)
			Graphics[indx++] =Digit_graphic[x+('1'-0x30)*3];
		
		// DECIMAL POINT
		Graphics[indx++]=0;
		Graphics[indx++]=DECIMAL_POINT_ICON[0];
		Graphics[indx++]=0;
		
		// DECIMAL DIGIT
		for (x=0; x<3;x++)
			Graphics[indx++] =Digit_graphic[x+('4'-0x30)*3];
		Graphics[indx++]=0;

		//  DEGRE C ICON  
		for (i=0;i<strlen(DEGRE_C_ICON);i++)
			Graphics[indx++]=DEGRE_C_ICON[i];

		Graphics[indx++]=0;
	
		//  Send data Display graphics 
		Display_RESET_GRAPHICS_INDEX(); // reset indx
		
		for (i=0;i<5;i++)
		{
			for (j=7;j>=0;j--)
				Display_WRITE_GRAPHICS(Graphics[j*5+i]); // colonn 5*0+1
		}
	
		Set_Display_GRAPHICS_MODE();

	}
	
	if ((strcmp(argv[2],"4")==0))
	{
		printf ("light on all leds\n");
		
		// fill buffer 
		for (i=0;i<40;i++)
			Graphics[i] = 0xff;
		//  Send data Display graphics 
		Display_RESET_GRAPHICS_INDEX(); // reset indx
		
		for (i=0;i<5;i++)
		{
			for (j=7;j>=0;j--)
				Display_WRITE_GRAPHICS(Graphics[j*5+i]); // colonn 5*0+1
		}
	
		Set_Display_GRAPHICS_MODE();

	}

			
   
	close (fd_serial);	// close serial port
	return;
}



/**************************************/
/*  Send Text datas to Display matrix */
/**************************************/
void SendTextDisplayMatrix(char * sText)
{
	int i;
	char Text[8];
	
	// fill end of text with space if lenght < 8
	for (i=0;i<8;i++)
	{
		if (i>=strlen(sText))
			Text[i]=' ';
		else
			Text[i]=sText[i];
	}
	DisplaySendCommandData (SET_CHAR_0,Text[0]);
	DisplaySendCommandData (SET_CHAR_1,Text[1]);
	DisplaySendCommandData (SET_CHAR_2,Text[2]);
	DisplaySendCommandData (SET_CHAR_3,Text[3]);
	DisplaySendCommandData (SET_CHAR_4,Text[4]);
	DisplaySendCommandData (SET_CHAR_5,Text[5]);
	DisplaySendCommandData (SET_CHAR_6,Text[6]);
	DisplaySendCommandData (SET_CHAR_7,Text[7]);
}

/*******************************************/
/*  set DISPLAY IN TEXT MODE and STOP TIME */
/*******************************************/
void Set_Display_TEXT_MODE_and_STOP_TIME(void)
{
	DisplaySendCommandData (START_STOP_TIME_COMPUTE,0x01);  // stop time
	DisplaySendCommandData (START_STOP_GRAPHICS,TEXT_MODE); // text mode
}
/*****************************/
/*  set DISPLAY IN TEXT MODE */
/*****************************/
void Set_Display_TEXT_MODE(void)
{
	DisplaySendCommandData (START_STOP_GRAPHICS,TEXT_MODE); // text mode
}

/*********************************/
/*  set DISPLAY IN GRAPHICS MODE */
/*********************************/
void Set_Display_GRAPHICS_MODE(void)
{
	DisplaySendCommandData (START_STOP_GRAPHICS,GRAPHICS_MODE); // graphic mode
}

/*************************/
/*  reset GRAPHICS index */
/*************************/
void Display_RESET_GRAPHICS_INDEX(void)
{
	DisplaySendCommandData(START_WRITE_GRAPHICS,0x00);	// reset indx
}	
/*************************/
/*  write data graphics */
/*************************/
void Display_WRITE_GRAPHICS(int data)
{
	DisplaySendCommandData(DATA_WRITE_GRAPHICS,data);
}	
/******************/
/*  Clear DISPLAY */
/******************/
void Display_CLEAR(void)
{
	DisplaySendCommandData(DISPLAY_ON_OFF,0x00);		// clear display Graphics
}
/***********************/
/*  DISPLAY STOP TIME  */
/***********************/
void Display_STOP_TIME(void)
{
	DisplaySendCommandData (START_STOP_TIME_COMPUTE,0x01); 
}

/***********************/
/*  DISPLAY START TIME  */
/***********************/
void Display_START_TIME(void)
{
	DisplaySendCommandData (START_STOP_TIME_COMPUTE,0x00); 
}

/*************************/
/*  LOW LEVEL FUNCTIONS */ 
/*************************/
int DisplaySendCommandData (int Cmd,int data)	
{ 
	char c [10];
	
	c[0] = (char) Cmd;
	c[1] = 0;
	write(fd_serial,&c,1);          //write 1 byte to the serial port
	RS232_delay_bit();
	c[0] = (char) data;
	c[1] = 0;
	write(fd_serial,&c,1);          //write 1 byte to the serial port
	RS232_delay_bit();
	
	return 1;	
}

void RS232_delay_bit (void)
{
	usleep(200);
}

/*********************/
/*  Open serial port */ 
/*********************/
void OpenPort (char * device)	
{ 
	fd_serial = open(device, O_RDWR | O_NOCTTY | FNDELAY);
   	if (fd_serial < 0)
   	{
		printf ("Error openning device : %s\n",device);
		exit(0);
	}
	
	bzero(&newtio,sizeof(newtio));
   
	newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR | ICRNL;
	newtio.c_oflag = 0;
	newtio.c_lflag = 0;       //ICANON;
	newtio.c_cc[VMIN]=1;
	newtio.c_cc[VTIME]=0;
	tcflush(fd_serial, TCIFLUSH);
	tcsetattr(fd_serial,TCSANOW,&newtio);
}

